function y = mtimes(obj, x)

sf    = obj.sf;
sx    = obj.sx;
sy    = obj.sy;
sz    = obj.sz;
sw    = obj.sw;
f     = obj.f;
z     = obj.z;     % precomputed fft
shape = obj.shape;

if obj.tp
  % transposed case
  switch shape
   case 'valid'
    x = [zeros(sw-1), zeros(sw(1)-1, sy(2));
         zeros(sy(1), sw(2)-1), x];     % zero padding
   case 'same'
    sw2 = floor(sw/2);
    xx = zeros(sz);
    xx(sw2(1)+(1:sy(1)), sw2(2)+(1:sy(2))) = x;
    x = xx;
  end
  y = ifftn(fftn(x) .* conj(z)); 
  y = y(1:sx(1), 1:sx(2));
else
  % not transposed case
  y = ifftn(fftn(x, sz).* z);
  switch shape
   case 'valid'
    y = y(sw(1):end, sw(2):end);
   case 'same'
    sw2 = floor(sw/2);
    y = y((sw2(1)+1):end, (sw2(2)+1):end);
    y = y(1:sy(1), 1:sy(2));
  end
end
y = real(y);